style("HuWalls", Walls, {
    'texture': 'humanwall',
    'start': flip('humanwall-end', fliph=True),
    'first_start': 'humanwall-invertcorner',
    'last_end': flip('humanwall-invertcorner', fliph=True)
   })

style('HuSwitch', Switch, {
    'shapes': [Circle(8, under=True, image="human-button")],
    })

style('HuBox', Package, {
    'texture':"humanboxwall", 'bg':"humanboxbg"
    })
    

style("DEInWalls", Walls, {
    'texture': 'humandoublewall',
    'startcorner': False,
    'start': flip('humandoublewall-end', fliph=True)
    })

style('InvertEn',Controlled, {
    'shapes': [Circle(12, density=5, image='invertebrate', inanim='invertebrate-in')],
    'size': 12, 'health': 100, 'bulletstyle': 'invertebrate', 'hurtsound': 'hiss.ogg',
    'diesound': 'invertdie.ogg',
    'outanim': "invertebrate-%(killer)sdeath",
    'ai': ai.DoesAll(ai.Wanders(speed=4),
                     ai.Targets(period=80, strength=10, killstr='enemy')),
        }
     )

style('MineLayer', InvertEn, {
    'shapes': [Circle(12, density=5, image='bomber')],
    'ai':ai.DoesAll(ai.Seeds(period=20), ai.Targets(period=0),
                    ai.Wanders()),
    'bulletai':ai.Damps(0.0, 0.4),
    'bulletpos': (0, 0),
    'outanim': 'bomber-%(killer)sdeath'
    }
      )

style('EnWalls', Walls, {
    'texture': 'enemywall',
    'startcorner': "enemywall-tee",
    'endcorner': rotate(flip("enemywall-tee", fliph=True), 90),
    'use_endcorner': False, 'use_startcorner': False
    }
      )

# Joined EnemyWalls. Forces the startcorner to be on, but not the
# endcorner, in case we need to use corners_at or last_end.
style('JEnWalls', EnWalls, {
    'use_startcorner': True
    }
      )

# Doubly joined enemy walls. Both startcorner and endcorner are on.
# This is the most common case, I think.
style('DJEnWalls', JEnWalls, {
    'use_endcorner': True
    }
      )

styles = {
    'InWalls':
    (Walls, {
        'texture': 'humandoublewall',
        'endcorner': rotate('humandoublewall-startcorner', 90),
        'start': flip('humandoublewall-end', fliph=True),
        'use_start': False, 'use_end': False,
        'use_first_start': False, 'first_start': 'humandoublewall-tee',
        'use_last_end': False, 'last_end': 'humandoublewall-tee'
    }
     ),

    'VertEn':
    (Controlled, {
        'size': 12, 'shapes': [Circle(12, density=5, image='vertebrate')],
        'static': True, 'health': 200,
        'ai': ai.Targets(period=30, turnspeed=2, strength=10),
        'attackimg': 'vertebrate-attack',
        'bulletstyle': 'vertebrate'
        }
     ),
    'BigEn':
    (Controlled, {
        'health': None, 'shapes':[Circle(24, image="boss1", density=3.75)],
        'ai': ai.DoesAll(ai.Wanders(speed=0.5), ai.Targets(period=300, strength=30, size=8, killstr='capt', forcescale=3.0)),
        'attackimg':'boss1-attack', 'bulletstyle': 'boss', 'diesound':"bossdie2.ogg",
        'hitsound': 'thud.ogg',
        'outanim': "bossdeath",
        }
     ),
    'Anchor':
    (Circle, {
        'radius': 20, 'image': 'anchor', 'static': True,
        }
     )
}
